// ============================================================================
//
// Copyright (c) 2010 - 2016, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ===================================================================


package ch.niceideas.common.http.comet.message;

import ch.niceideas.common.http.comet.CometManager;
import ch.niceideas.common.http.comet.CometServerException;
import ch.niceideas.common.service.Registry;
import ch.niceideas.common.service.WebRegistry;
import org.apache.commons.lang.StringUtils;
import org.apache.log4j.Logger;

import javax.servlet.http.HttpServletRequest;

/**
 * Handles dispatching of messages from clients to others as well as broadcasting of messages. 
 */
public class SystemMessageHandler implements MessageHandler {

    private static final Logger logger = Logger.getLogger(SystemMessageHandler.class);
    
    /**
     * {@inheritDoc}
     */
    @Override
    public boolean accept(HttpServletRequest request, String streamId, String clientId, String message) throws CometServerException {

        Registry registry = new WebRegistry(request.getSession());
        CometManager manager = (CometManager) registry.getService(CometManager.class.getCanonicalName());

        if (StringUtils.isNotBlank(clientId)) {
            manager.dispatch(streamId, clientId, message);
        } else {
            manager.dispatchAll(streamId, message);
        }
        
        return true;
    }

}
