// ============================================================================
//
// Copyright (c) 2010 - 2011, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ===================================================================


package ch.niceideas.common.service;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * An annotation for classes to be discovered and stored in a Registry.
 * <br />
 * Classes only need to declare this annotation above their type declaration and will be automagically discovered
 * by the RegistryInitializer.
 * <p />
 *
 * At the moment only application (i.e. static) scope is supported.
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.TYPE)
public @interface Service {

    Registry.Scope scope = Registry.Scope.APPLICATION;
}
