// ============================================================================
//
// Copyright (c) 2010 - 2016, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ===================================================================



//
// initialization
// ----------------------------------------------------------------------------
// 

var rexp = new RegExp('(http://[^/\\?]*/[^/:\\?]*(/){0,1}).*', 'gi');

var messageWindowLocation = null;

if (!window.addEventListener) {
   window.addEventListener = function (type, listener, capt) {
       attachEvent('on'+type, function(){listener(event)});
   }
}

//
// functions
// ----------------------------------------------------------------------------
// 

/*
 * Utility functions
 */

getWindowLocation = function() {
	if (messageWindowLocation == null) {	    
	    var matches =  rexp.exec(''+window.location);
	    messageWindowLocation = matches[1];
	}
	return messageWindowLocation;
}


/**
 * Message from client frame (not used for now)
 */
onClientMessage = function(e) {
	console.log ("onClientMessage", e);
    alert (e);
}
addEventListener('message', onClientMessage);


/**
 * This the actual function called by the backend Side when a command / message
 * needs to be passed to the frontend.
 * <p />
 * 
 * This function simply passed the message forward from the iframe to the main 
 * frame.
 * <p />
 * 
 * It used inter-frame communication system provided by the browser.
 */
processMessage = function (serverMessage) {
	parent.postMessage(serverMessage, getWindowLocation());
}

