// ============================================================================
//
// Copyright (c) 2010 - 2016, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ===================================================================



var EXTRACT_MESSAGE_REXP = "(.*):([a-zA-Z0-9_\-]*):(.*)";
var myPosition = "none";
var myWinCount = 0;
var otherWinCount = 0;
var gameRunning = false;

/**
 * Handle comet messages coming from backend
 */
handleServerMessage = function (msg) {
    //console.log (msg);
    
    var paramsRexp = new RegExp(EXTRACT_MESSAGE_REXP, 'gi')    
    
    if (msg.indexOf ("NOTIFICATION") == 0) {
        
        alert (msg.substring(13));
        
    } else if (msg.indexOf ("POS") == 0) {
        
        var matches =  paramsRexp.exec(msg);
        var position = matches[3]
        
        if (matches[2] == myClientId) { // I move
            
            var pad = document.getElementById(myPosition + "Pad");
            pad.style.top = position + "px";
                
        } else { // Other move
            
            var pad = document.getElementById( (myPosition == "left" ? "right" : "left") + "Pad");
            pad.style.top = position + "px";
        }
        
    } else if (msg.indexOf ("BALL_POS") == 0) {
        
        var matches = paramsRexp.exec(msg);
        var position = matches[3];
        var ball = document.getElementById("ball");
        
        if (matches[1] == "BALL_POS_X") {
            ball.style.left = position + "px";
        } else {
            ball.style.top = position + "px";
        }
                
    } else if (msg.indexOf ("FIRST_PLAYER_WIN") == 0) {
        myWinCount++;
        document.getElementById('leftCounter').innerHTML = "" + myWinCount;
        
    } else if (msg.indexOf ("SECOND_PLAYER_WIN") == 0) {
        otherWinCount++;
        document.getElementById('rightCounter').innerHTML = "" + otherWinCount;
        
    } else if (msg.indexOf ("FIRST_PLAYER") == 0) {
        myPosition = "left";
        alert ("Game Id is '" + msg.substring(13) + "'");
        
    } else if (msg.indexOf ("SECOND_PLAYER") == 0) {
        myPosition = "right";
        //alert (myPosition);      
    }
    
};

/*
 * Game control
 */
boardKeyUp = function (e) {
    if (gameRunning && e.keyCode) {
        if (e.keyCode == 40) {
            sendControlMessage ("GAME", "STOP_DOWN"); stopEvent(e);
        } else if (e.keyCode == 38) {
            sendControlMessage ("GAME", "STOP_UP"); stopEvent(e);
        }
    }
};
boardKeyDown = function (e) {
    //alert (e.keyCode);
    if (gameRunning && e.keyCode) {
        if (e.keyCode == 40) {
            sendControlMessage ("GAME", "START_DOWN"); stopEvent(e);
        } else if (e.keyCode == 38) {
            sendControlMessage ("GAME", "START_UP"); stopEvent(e);
        }
    }
};

/*
 * Game Management
 */

initGame = function() {
    initServerConnection('GAME', true);
    sendControlMessage ("GAME", "INIT");
    myWinCount = 0;
    otherWinCount = 0;
    gameRunning = true;
};

joinGame = function() {
    initServerConnection('GAME', true);
    sendControlMessage ("GAME", "JOIN:" + document.getElementById('targetGameId').value);
    myWinCount = 0;
    otherWinCount = 0;
    gameRunning = true;
};

quitGame = function() {
    dropServerConnection('GAME'); 
    gameRunning = false;
};
